	; disable some optimization
	opt o-, o1+, o3+, a+


	; exception overrides
	rorg $0008
		dc.l	exception_bus, exception_address, exception_instruction, exception_zero

	; injection point, right before the code that waits for the kabuki (see below)
	rorg $7656
		jmp	debug_code


	; point after the normal qsound ram check
	rorg $7688
return_point:



	; this address is a chunk of free space in tk2u_22c.7f
	rorg $e6860
debug_code:


	; this is the normal stall until kabuki writes 0x77 to that
	; address in the upper qsound shared ram block
	.loop_wait_kabuki:
		move.w	$f19ffe.l, D0
		cmpi.b	#$77, D0
		bne	.loop_wait_kabuki


	; this is a slightly modified ram test that normally runs on the lower
	; qsound shared ram block.  we save the read word into d1, instead of
	; a direct memory comparison
		movea.l	#$f18000, a0	; lower qsound shared ram block
		move.w	#$ffe, d0	; number of words to test
	.loop_next_address:
		move.w	#$ffff, (a0)
		move.w	(a0)+, d1

		; if this nop or any instruction exists here it
		; causes an exception
		; nop
		cmp.w	#-$1, d1
		beq	.address_good
		move.w	#$ffff, d0	; expected value
		jsr	print_data_error

	.address_good:
		dbra	d0, .loop_next_address

		; if uncommented will print "PASS" and stall instead of
		; returning to the game code.
		;bra	print_pass_stall

		jmp	return_point


; little unclear here on real hardware.  If the nops are missing
; the lea never gets run
	align 4
exception_bus:
		nop
		nop
		lea	STR_EXCEPTION_BUS, a0
		bra	dump_exception_type_a

	align 4
exception_address:
		nop
		nop
		lea	STR_EXCEPTION_ADDRESS, a0
		bra	dump_exception_type_a

	align 4
exception_instruction:
		nop
		nop
		lea	STR_EXCEPTION_INSTRUCTION, a0
		bra	dump_exception_type_b

	align 4
exception_zero:
		nop
		nop
		lea	STR_EXCEPTION_ZERO, a0
		bra	dump_exception_type_b

dump_exception_type_a:
		moveq	#$4, d0
		moveq	#$a, d1
		jsr	seek_xy
		jsr	print_string

		moveq	#$4, d0
		moveq	#$d, d1
		jsr	seek_xy
		lea	STR_PC, a0
		jsr	print_string

		moveq	#$16, d0
		moveq	#$d, d1
		jsr	seek_xy
		move.l	(10,a7), d2
		jsr	print_hex_long

		moveq	#$4, d0
		moveq	#$f, d1
		jsr	seek_xy
		lea	STR_ADDRESS, a0
		jsr	print_string

		moveq	#$16, d0
		moveq	#$f, d1
		jsr	seek_xy
		move.l	(2,a7), d2
		jsr	print_hex_long


	.stall:
		bra .stall

dump_exception_type_b:
		moveq	#$4, d0
		moveq	#$a, d1
		jsr	seek_xy
		jsr	print_string

		moveq	#$4, d0
		moveq	#$d, d1
		jsr	seek_xy
		lea	STR_PC, a0
		jsr	print_string

		moveq	#$16, d0
		moveq	#$d, d1
		jsr	seek_xy
		move.l	(2,a7), d2
		jsr	print_hex_long

	.stall:
		bra	.stall

print_pass_stall:
		moveq	#$14, d0
		moveq	#$a, d1
		jsr	seek_xy
		lea	STR_PASS, a0
		jsr	print_string
	.stall:
		bra	.stall

; a0 = address
; d0 = expected
; d1 = actual
print_data_error:
		move.w	d0, d5		; backup expected/actual/address
		move.w	d1, d6
		move.l	a0, d4
		subq.l	#2, d4		; sub 2 because of (a0)+ above

		; address
		moveq	#$14, d0
		moveq	#$a, d1
		jsr	seek_xy
		move.l	d4, d2
		jsr	print_hex_3_bytes

		moveq	#$4, d0
		moveq	#$a, d1
		jsr	seek_xy
		lea	STR_ADDRESS, a0
		jsr	print_string

		; expected
		moveq	#$16, d0
		moveq	#$c, d1
		jsr	seek_xy
		move.w	d5, d2
		jsr	print_hex_long

		moveq	#$4, d0
		moveq	#$c, d1
		jsr	seek_xy
		lea	STR_EXPECTED, a0
		jsr	print_string

		; actual
		moveq	#$16, d0
		moveq	#$e, d1
		jsr	seek_xy
		move.w	d6, d2
		jsr	print_hex_long

		moveq	#$4, d0
		moveq	#$e, d1
		jsr	seek_xy
		lea	STR_ACTUAL, a0
		jsr	print_string

	.stall:
		bra	.stall

		rts

print_string:
	.next_char:
		moveq	#$0, d0
		move.b	(a0)+, d0
		beq	.end_string
		addi.w	#-$3000, d0
		move.w	d0, (a5)+
		move.w	#$0, (a5)
		lea	($7e,a5), a5
		bra	.next_char
	.end_string:
		rts


; params
;  d0 = x
;  d1 = y
; returns
;  a5 = grx address
seek_xy:
		lsl.l	#7, d0
		move.b	d1, d2
		andi.l	#$ff, d2
		add.w	d2, d2
		add.w	d2, d2
		add.w	d2, d0
		addi.l	#$908000, d0
		movea.l	d0, a5
		rts

print_hex_word:
		moveq	#3, d1
		bra	print_hex

print_hex_3_bytes:
		moveq	#5, d1
		bra	print_hex

print_hex_long:
		moveq	#7, d1

; d1 = chars to print
; d2 = data
print_hex:

		bra	.loop_start
	.loop_next_hex:
		lsr.l	#4, d2
	.loop_start:
		moveq	#$f, d0
		and.b	d2, d0
		move.b	(HEX_LOOKUP,PC,d0.w), d0
		addi.w	#-$3000, d0
		move.w	d0, (a5)+
		move.w	#$0, (a5)
		lea	(-$82, a5), a5
		dbra	d1, .loop_next_hex
		rts

HEX_LOOKUP:	dc.b	"0123456789ABCDEF"

	macro STRING
		dc.b \1, $0
		align 2
	endm


STR_ADDRESS:	STRING "ADDRESS"
STR_EXPECTED:   STRING "EXPECTED"
STR_ACTUAL:     STRING "ACTUAL"
STR_PASS:	STRING "PASS"

STR_EXCEPTION_BUS:		STRING "EXCEPTION BUS"
STR_EXCEPTION_ADDRESS:		STRING "EXCEPTION ADDRESS"
STR_EXCEPTION_INSTRUCTION:	STRING "EXCEPTION INSTRUCTION"
STR_EXCEPTION_ZERO:		STRING "EXCEPTION ZERO"
STR_PC:				STRING "PC"
